/*
 * J2F File Format Prototypes
 */

//Zlib and stream shit

#define STRM_SUCCESS			0
#define STRM_NO_DATA			1 //invalid state; nothing to (de)compress
#define STRM_OUT_OF_MEMORY		2 //memory allocation failed
#define STRM_OPERATION_FAILED	3 //compression or decompression operation failed
#define STRM_UNEXPECTED_SIZE	4 //the decompressed stream size was unexpected

typedef struct cstream {
	unsigned long	compSize;
	unsigned long	uncompSize;
	unsigned char	*compData;
	unsigned char	*uncompData;
} cstream, *cstreamP;

cstreamP	newStream(void);
void		destroyStream(cstreamP stream);
int			uncompressStream(cstreamP st);
int			compressStream(cstreamP st);


//J2F shit

#define J2F_TYPE_LEVEL		1
#define J2F_TYPE_TILESET	2

#define J2F_SUCCESS					0
#define J2F_FAILURE					1
#define J2F_OUT_OF_MEMORY			2
#define J2F_COULD_NOT_OPEN_FILE		3
#define J2F_INVALID_FILE			4

/* J2F File prologue and streams */
typedef struct J2FFile {
	char		copyrightMessage[180];
	char		magic[4];
	union {
		struct {
			char		passwordHash[3];	// J2L-exclusive: crc32(password) & 0xFFFFFF
			char		hideLevel;			// J2L-exclusive: hide level from Home Cooked
		}; //4 bytes
		long			Signature;		// J2T-exclusive: DEADBEAF
	};
	char		levelName[32];
	short		version;
	long		fileSize;
	long		CRC32;
	cstreamP	stream[4];
} J2FFile, *J2FFileP;

J2FFileP	newJ2FFile(void);
void		destroyJ2FFile(J2FFileP head);
//takes J2F_TYPE_LEVEL or J2F_TYPE_TILESET as last argument
//Return J2F + SUCCESS, FAILURE, OUT_OF_MEMORY, COULD_NOT_OPEN_FILE or INVALID_FILE
int			readJ2FFile(const wchar_t *lvl, J2FFileP head, int type);

#define J2F_MAX_LEVEL_NAME_SIZE 31

typedef struct LevelInformation {
	short		version;
	char		levelName[32];
	char		tileSet[32];
	char		bonusLevel[32];
	char		nextLevel[32];
	char		secretLevel[32];
	char		musicFile[32];
} LevelInfo, *LevelInfoP;

//Return J2F + SUCCESS, FAILURE, OUT_OF_MEMORY, COULD_NOT_OPEN_FILE or INVALID_FILE
int readLevelInformation(const wchar_t *file, LevelInfoP lvlinfo);
